#include "xpvox.h"

FD_xpvox *fdui;

pthread_t play_thread;
static pid_t play_pid;

#ifdef TIMING_CHECKS
unsigned long lstart_usecs, lcurrent_usecs, ldiff_usecs;
int have_time;
#endif // TIMING_CHECKS


int player(char *pathfilename)
{
int a;
char *extention;
char temp[4096];
char progname[80];
char *arg[27];
FILE *pptr;

#ifdef USE_FREOPEN
//FILE *frpstdin;
FILE *frpstdout;
#endif // USE_FREOPEN

if(debug_flag)
	{
	fprintf(stderr,\
	"player(): arg pathfilename=%s, using show_picture_flag=%d\n",\
	pathfilename, show_picture_flag);
	}

if(! pathfilename) return 0;

//show_picture_flag = 1;

/* get extention .wav .mp3 */
extention = strrchr(pathfilename, '.');
if(! extention)
	{
	fprintf(stderr, "player(): no audio extention specified in %s\n", pathfilename);

	return 0;
	}
if(strcmp(extention, ".wav") == 0)
	{
	if(use_xpequ_flag)
		{
		// for using AGC in xpequ output to /dev/dsp0
		/* xpequ -i file.wav -t hw:0,0 -u hw:1,0 */
		sprintf(temp, "xpequ -i %s -t hw:0,0 -u hw:1,0", pathfilename);
		pptr = popen(temp, "w");
		pclose(pptr);

		return 1;
		}

	//	do not use 'play' as it calls sox with a new PID, then it cannot be killed.
	//	sox example.wav -t ossdsp /dev/dsp2 	
	strcpy(progname, "sox");
	sprintf(temp, "%s", audio_output_device);

	arg[0] = progname;
	arg[1] = pathfilename;
	arg[2] = "-t";
	arg[3] = "ossdsp";
	arg[4] = temp;
	arg[5] = NULL;
	}
else if(strcmp(extention, ".mp3") == 0)
	{
	if(use_xpequ_flag)
		{
		// for using AGC in xpequ output to /dev/dsp0
		/* mpg123 -w - file.mp3 | xpequ -i - -t hw:0,0 -u hw:1,0 */
		sprintf(temp, "mpg123 -w - %s | xpequ -i - -t hw:0,0 -u hw:1,0", pathfilename);
		pptr = popen(temp, "w");
		pclose(pptr);

		return 1;
		}
	
//	mpg123 -a /dev/dsp2 example.mp3
	strcpy(progname, "mpg123");
	sprintf(temp, "%s", audio_output_device);

	arg[0] = progname;
	arg[1] = "-a";
	arg[2] = temp;
	arg[3] = pathfilename;
	arg[4] = NULL; 
	}
else if(strcmp(extention, ".mp2") == 0)
	{
	if(use_xpequ_flag)
		{
		// for using AGC in xpequ output to /dev/dsp0
		/* mpg123 -w - file.mp2 | xpequ -i - -t hw:0,0 -u hw:1,0 */
		sprintf(temp, "mpg123 -w - %s | xpequ -i - -t hw:0,0 -u hw:1,0", pathfilename);
		pptr = popen(temp, "w");
		pclose(pptr);

		return 1;
		}
	
	//	mpg123 -a /dev/dsp2 example.mp2
	strcpy(progname, "mpg123");
	sprintf(temp, "%s", audio_output_device);

	arg[0] = progname;	
	arg[1] = "-a";
	arg[2] = temp;
	arg[3] = pathfilename;
	arg[4] = NULL; 
	}
else if(strcmp(extention, ".mpa") == 0)
	{
	if(use_xpequ_flag)
		{
		// for using AGC in xpequ output to /dev/dsp0
		/* mpg123 -w - file.mpa | xpequ -i - -t hw:0,0 -u hw:1,0 */
		sprintf(temp, "mpg123 -w - %s | xpequ -i - -t hw:0,0 -u hw:1,0", pathfilename);
		pptr = popen(temp, "w");
		pclose(pptr);

		return 1;
		}
	
//	mpg123 -a /dev/dsp2 example.mpa
	strcpy(progname, "mpg123");
	sprintf(temp, "%s", audio_output_device);

	arg[0] = progname;	
	arg[1] = "-a";
	arg[2] = temp;
	arg[3] = pathfilename;
	arg[4] = NULL; 
	}
else // all other formats, note starting up mplayer is slow.
	{
//	mplayer -ao' 'oss:/dev/dsp2 -vo null example.xxx
	strcpy(progname, "mplayer");
	sprintf(temp, "oss:%s", audio_output_device);

	arg[0] = progname;
	arg[1] = "-ao";
	arg[2] = temp;
	if(show_picture_flag)
		{
		arg[3] = pathfilename;
		arg[4] = NULL;
		}
	else
		{
		arg[3] = "-vo";
		arg[4] = "null";
		arg[5] = pathfilename;
		arg[6] = NULL;
		}
	}

/* prevent writing to the terminal via stderr */
#ifdef USE_FREOPEN

//frpstdin = freopen("/dev/zero", "w", stdout);
frpstdout = freopen("/dev/zero", "w", stderr);

a = execvp(progname, arg);

//freopen("/dev/fd/1", "w", frpstdin);
freopen("/dev/fd/2", "w", frpstdout);

#else

//fclose(stdout);
//stderr = fopen ("/dev/zero", "w");

fclose(stderr);
stdout = fopen ("/dev/zero", "w");

a = execvp(progname, arg);

//fclose(stdout);
//stdout = fopen ("/dev/fd/1", "w");

fclose(stderr);
stderr = fopen ("/dev/fd/2", "w");

#endif // ! USE_FREOPEN

return 1;
} /* end function player */


void *play_routine()
{
int a;
char *ptr;
pid_t pid;
int status;

if(debug_flag)
	{
	fprintf(stderr, "play_routine(): arg none\n");
	}

#ifdef TIMING_CHECKS
if(! have_time)
	{
	gettimeofday(current_timeval, NULL);
	lcurrent_usecs =\
	current_timeval -> tv_usec + (1000000 * current_timeval -> tv_sec);

	ldiff_usecs = lcurrent_usecs - lstart_usecs;

	fprintf(stderr, "play_thread startup was %lu micro seconds.\n", ldiff_usecs);

	have_time = 1;
	}
#endif // TIMING_CHECKS

/* a = 0 is not found */
ptr = line_to_filename(player_sound);
if(! ptr)
	{
	fprintf(stderr, "xpvox: ERROR: play_routine(): line_to_filename(%d) failed\n.", player_sound);

	return NULL;
	}
else
	{
	pid = fork();
	if(pid == -1) {}
	else if(pid == 0) player(ptr);
	else
		{	
		play_pid = pid;

		if(debug_flag)
			{
			fprintf(stderr, "play_pid=%d\n", play_pid);
			}	

		if( waitpid(play_pid, &status, 0) != play_pid) {};

		playing_flag = 0;
		}

	pthread_exit(&a);

	} /* end if ptr */

if(debug_flag)
	{
	printf("exit play_process()\n");
	}

return NULL;
} /* end function play_routine */


int play_init()
{
int a, b;

if(debug_flag)
	{
	printf("play_init(): arg none\n");
	}

playing_flag = 1;

pthread_create(&play_thread, NULL , &play_routine, NULL);

b = pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, &a);
//fprintf(stderr, "cancelstate a=%d b=%d\n", a, b);

b = pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, &a);
//fprintf(stderr, "canceltype a=%d b=%d\n", a, b);

return 1;
} /* end function play_init */


void start_player(int mode)
{
if(debug_flag)
	{
	printf("start_player() arg mode=%d using playing_flag=%d\n", mode, playing_flag);
	}

while(1)
	{
	if(! playing_flag) break;

	usleep(1000);
	}

if(! get_sound(mode, &player_sound) )
	{
	if(debug_flag)
		{
		fprintf(stderr, "start_player(): get_sound() failed\n");
		}

	return;
	}

if(debug_flag)
	{
	fprintf(stderr,\
	"start_player(): player_sound=%d auto_play_sequence_number=%d\n",\
	player_sound, auto_play_sequence_number);
	}

#ifdef TIMING_CHECKS
have_time = 0;
gettimeofday(start_timeval, NULL);
lstart_usecs =\
start_timeval -> tv_usec + (1000000 * start_timeval -> tv_sec);
#endif // TIMING_CHECKS

play_init();

/* force logging if enabled */
old_rts_is_on_flag = -1;
} /* end function start_player */


void stop_player()
{
char temp[80];
FILE *pptr;

if(debug_flag)
	{
	printf("stop_player(): arg none\n");
	}

if(! playing_flag) return;

sprintf(temp, "kill -KILL %d", play_pid );
pptr = popen(temp, "w");
pclose(pptr);

if(debug_flag)
	{
	fprintf(stderr, "killed pid %d\n", play_pid);
	}

//pthread_cancel(play_thread);

} /* end function stop_player */


